/*
	MIT License http://www.opensource.org/licenses/mit-license.php
	Author Tobias Koppers @sokra
*/
var loaderUtils = require('loader-utils'),
	path = require('path'),
	nativeCss = require('native-css/index.js')
	fs = require('fs'),
	querystring = require('querystring');

module.exports = function(content) {
	// more testing neede - i don't know how to handle / if i shoul use cache
	// this.cacheable && this.cacheable();
	if(!this.emitFile) throw new Error('emitFile is required from module system');
	// parameters
	var query = loaderUtils.parseQuery(this.query);
	// construct tmp url
	var url = loaderUtils.interpolateName(this, query.name || '[hash].[ext]', {
		context: query.context || this.options.context,
		content: content,
		regExp: query.regExp
	});
	// setup the new path
	var pathTemp 		= __dirname + '/tmp/'
	,	newUrl 		= pathTemp+url
	;
	// writeout to cssobjects-loader/tmp
	fs.readdir(pathTemp, function(err) {
		var callback 	= function(){ console.log('[objectscss-loader] tmp file written', newUrl) }
		,	writeFile 	= function(cb) {
				fs.writeFile(newUrl, content, 'utf8', function(err) {
					if (typeof cb === 'function')
						cb();
				});
			}
		;
		writeFile(callback);
	});
	// compile + toSting
	var compiled 		= nativeCss.convert( newUrl )
	,	compiledJson 	= JSON.stringify(compiled)
	;

console.log('nativeCss', nativeCss);
console.log('compiledJson', compiledJson);

// ? - not neccessary to emit a file
this.emitFile(url, compiledJson);

	// __webpack_public_path__ +
	return 'module.exports =   ' + compiledJson + ';';
}
module.exports.raw = true;
